import { Endpoint, EndpointImpl } from "../endpoint";
import { Model, ModelImpl } from "../model/Model";
import { LifeCircle } from "./LifeCircle";
import { Service, ServiceEventImpl } from "../service/Service";
import { DataBase } from "../database";
import { Trigger, TriggerListener } from "../trigger";
import { CoreState } from "./CoreState";
export declare class Core implements EndpointImpl<Core>, ModelImpl<Core>, LifeCircle, ServiceEventImpl {
    readonly dataBase: DataBase;
    readonly trigger: Trigger;
    private _endpoints;
    private _models;
    private _coreState;
    private _services;
    constructor(dataBase: DataBase);
    createAndStart(): Promise<void>;
    stopAndDestroy(): Promise<void>;
    create(): Promise<void>;
    start(): Promise<void>;
    stop(): Promise<void>;
    destroy(): Promise<void>;
    addEndpoint(name: string, endpoint: Endpoint): void;
    addModel(init: (t: Core) => Model): void;
    addService(service: Service): void;
    removeService(service: Service): void;
    addTrigger(listener: TriggerListener): void;
    getEndpoint(name: string): Endpoint;
    getModel(name: string): Model;
    getState(): CoreState;
    getModels(): Model[];
}
