"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const winston_1 = __importDefault(require("winston"));
const alignedWithColorsAndTime = winston_1.default.format.combine(winston_1.default.format.colorize(), winston_1.default.format.timestamp(), winston_1.default.format.align(), winston_1.default.format.printf((info) => {
    const { timestamp, level, message } = info, args = __rest(info, ["timestamp", "level", "message"]);
    const ts = timestamp.slice(0, 19).replace("T", " ");
    return `${ts} [${level}]: ${message} ${Object.keys(args).length ? JSON.stringify(args, null, 2) : ""}`;
}));
const folder = `log/${new Date(Date.now()).toDateString()}/${Date.now()}/`;
if (process.env.NODE_ENV !== "production") {
    winston_1.default.add(new winston_1.default.transports.File({
        format: alignedWithColorsAndTime,
        filename: `${folder}combined.log`,
        level: "info"
    }));
    winston_1.default.add(new winston_1.default.transports.File({
        format: alignedWithColorsAndTime,
        filename: `${folder}errors.log`,
        level: "error"
    }));
    winston_1.default.add(new winston_1.default.transports.Console({
        format: alignedWithColorsAndTime
    }));
}
exports.default = winston_1.default;
//# sourceMappingURL=Logger.js.map