import { Model } from "../model";
import { Value } from "../model/Model";
import { DB, FilterOption } from "../model/find/FindFilter";
export default abstract class DataBase {
    abstract connect(): Promise<void>;
    abstract disconnect(): Promise<void>;
    abstract createTable(model: Model): Promise<void>;
    abstract insertByModel(data: Value, model: Model): Promise<Value>;
    abstract updateByModel(data: Value, model: Model, filter: DB.DBFilter): Promise<void>;
    abstract deleteByModel(model: Model, filter: DB.DBFilter): Promise<void>;
    abstract findByModel(model: Model, filter: DB.DBFilter, option?: FilterOption): Promise<Value[]>;
}
