import { DataBase } from "./index";
import { DB, FilterOption, Model, Value } from "../model";
import DBFilter = DB.DBFilter;
export default class MongoDB extends DataBase {
    private _mongoDBClient;
    private _database;
    private readonly port;
    private readonly name;
    private readonly collection;
    constructor(port: number, name: string);
    private static buildToMongoDBFilter;
    private static buildToMongoDBFindOption;
    connect(): Promise<void>;
    disconnect(): Promise<void>;
    createTable(model: Model): Promise<void>;
    deleteByModel(model: Model, filter: DBFilter): Promise<void>;
    findByModel(model: Model, filter: DBFilter, option?: FilterOption): Promise<Value[]>;
    insertByModel(data: Value, model: Model): Promise<Value>;
    updateByModel(data: Value, model: Model, filter: DBFilter): Promise<void>;
}
