import { Core, LifeCircle } from "../core";
import { ApiRequest, PathConfig } from "./generator";
export declare abstract class Endpoint implements LifeCircle {
    protected core: Core;
    init(core: Core): Promise<void>;
    create(): Promise<void>;
    destroy(): Promise<void>;
    start(): Promise<void>;
    stop(): Promise<void>;
    generateApiRequest(option: PathConfig): ApiRequest[];
    addApiRequest(request: ApiRequest | ApiRequest[]): void;
    protected abstract useRequest(request: ApiRequest): void;
}
export interface EndpointImpl<T> {
    addEndpoint(name: string, endpoint: Endpoint): void;
    getEndpoint(name: string): Endpoint;
}
