"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Endpoint = void 0;
const core_1 = require("../core");
const generator_1 = require("./generator");
class Endpoint {
    init(core) {
        return __awaiter(this, void 0, void 0, function* () {
            this.core = core;
        });
    }
    create() {
        return __awaiter(this, void 0, void 0, function* () {
        });
    }
    destroy() {
        return __awaiter(this, void 0, void 0, function* () {
        });
    }
    start() {
        return __awaiter(this, void 0, void 0, function* () {
        });
    }
    stop() {
        return __awaiter(this, void 0, void 0, function* () {
        });
    }
    generateApiRequest(option) {
        const request = generator_1.ApiRequestGenerator(option);
        this.addApiRequest(request);
        return request;
    }
    addApiRequest(request) {
        if (this.core && this.core.getState() !== core_1.CoreState.Destroy) {
            core_1.Logger.error("Bad currently state. It must be destroy.");
            return;
        }
        if (Array.isArray(request)) {
            for (const apiRequest of request) {
                this.useRequest(apiRequest);
            }
        }
        else {
            this.useRequest(request);
        }
    }
}
exports.Endpoint = Endpoint;
//# sourceMappingURL=Endpoint.js.map