import { Error, ErrorType } from "../../../core";
export declare type Descriptor = (ParamDescription | ResultDescription | MetaDescription | GroupDescription)[];
export declare type ParamDescription = {
    object: "param";
    type: string;
    name: string;
    require: boolean;
    description: string;
    metaData: boolean;
};
export declare type ResultDescription = {
    object: "result";
    type: ErrorType;
    success: boolean;
    message: string;
    details?: any;
};
export declare type MetaDescription = {
    object: "meta";
    name: string;
    details: string;
};
export declare type GroupDescription = {
    object: "group";
    name: string;
    details: string;
};
export declare function param(name: string, type: string, metaData?: boolean, require?: boolean, description?: string): ParamDescription;
export declare function resultAsError(error: Error): ResultDescription;
export declare function result(success: boolean, message: string, details?: any): ResultDescription;
export declare function request(name: string, details: string): MetaDescription;
export declare function group(name: string, details: string): GroupDescription;
