"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.group = exports.request = exports.result = exports.resultAsError = exports.param = void 0;
const core_1 = require("../../../core");
function param(name, type, metaData = true, require = true, description = '') {
    return {
        object: "param",
        metaData,
        name,
        type,
        require,
        description
    };
}
exports.param = param;
function resultAsError(error) {
    return {
        object: "result",
        success: false,
        type: error.type,
        message: error.message,
        details: error.details
    };
}
exports.resultAsError = resultAsError;
function result(success, message, details) {
    return {
        object: "result",
        type: core_1.ErrorType.Request,
        success,
        message,
        details
    };
}
exports.result = result;
function request(name, details) {
    return {
        object: "meta",
        name,
        details
    };
}
exports.request = request;
function group(name, details) {
    return {
        object: "group",
        name,
        details
    };
}
exports.group = group;
//# sourceMappingURL=Descriptor.js.map