import { ErrorType } from "../../../core";
import { PathConfig } from "..";
export declare class DescriptionGroup {
    path: string;
    name: string;
    details: string;
    children: DescriptionGroup[];
    requests: DescriptionRequest[];
    constructor(path: string, name: string, details?: string);
}
export interface ApiParam {
    type: string;
    name: string;
    meta: boolean;
    description: string;
}
export interface ApiResult {
    type?: ErrorType;
    message: string;
    details: any;
}
export declare class DescriptionRequest {
    path: string;
    name: string;
    details: string;
    param: ApiParam[];
    paramsOptional: ApiParam[];
    success: ApiResult[];
    error: ApiResult[];
    constructor(path: string, name: string, details: string);
}
export default function generator(name: string, url: string, option: PathConfig): DescriptionGroup;
