"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateDelete = void 0;
const __1 = require("..");
function generateDelete(model, argName, idName) {
    return (core, args) => __awaiter(this, void 0, void 0, function* () {
        const filterObject = {};
        const error = [];
        // Check the validation of id
        __1.ifId(error, args.meta, argName);
        // Exist errors than break the request
        if (error.length > 0) {
            return { error };
        }
        // Read the filter id
        filterObject[idName] = args.meta[argName];
        // Get the model
        const modelObject = core.getModel(model);
        // And delete all entries of them id
        return modelObject.delete(filterObject).then(() => {
            return {};
        });
    });
}
exports.generateDelete = generateDelete;
//# sourceMappingURL=GenerateDelete.js.map