"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateList = void 0;
const __1 = require("..");
function generateList(model, idFilter = {}) {
    return (core, args) => __awaiter(this, void 0, void 0, function* () {
        const filterObject = {};
        const error = [];
        for (const key in idFilter) {
            // Check the validation of id
            __1.ifId(error, args.data, idFilter[key]);
            // Insert into the filter
            filterObject[key] = args.data[key];
        }
        // Exist errors than break the request
        if (error.length > 0) {
            return { error };
        }
        // Get the model
        const modelObject = core.getModel(model);
        // And search the ids of data
        return modelObject.find(filterObject).then((values) => {
            return {
                data: {
                    list: values.map((v) => v.id)
                }
            };
        });
    });
}
exports.generateList = generateList;
//# sourceMappingURL=GenerateList.js.map