"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateUpdate = void 0;
const core_1 = require("../../../core");
const __1 = require("..");
function generateUpdate(model, argName, idName, allowData = [], metaAsData = {}) {
    return (core, args) => __awaiter(this, void 0, void 0, function* () {
        const filterObject = {};
        const error = [];
        // Check the validation of id
        __1.ifId(error, args.meta, argName);
        // Check allow data
        for (const data in args.data) {
            let found = false;
            for (const allow of allowData) {
                if (allow === data) {
                    found = true;
                    break;
                }
            }
            if (found) {
                error.push({
                    type: core_1.ErrorType.Request,
                    message: `The argument of data '${data}' can not edit.`
                });
            }
        }
        // Copy some meta ids into the data args
        for (const metaDate in metaAsData) {
            // If it a id
            __1.ifId(error, args.meta, metaAsData[metaDate]);
            // Write the id into the data
            args.data[metaDate] = metaAsData[metaDate];
        }
        // Exist errors than break the request
        if (error.length > 0) {
            return { error };
        }
        // Read the filter id
        filterObject[idName] = args.meta[argName];
        // Get the model
        const modelObject = core.getModel(model);
        // And update all entries with them id of data
        return modelObject.update(args.data, filterObject).then((values) => {
            return {
                error: values
            };
        });
    });
}
exports.generateUpdate = generateUpdate;
//# sourceMappingURL=GenerateUpdate.js.map