"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ExecuteMiddleware_1 = __importDefault(require("../middleware/ExecuteMiddleware"));
const ArgumentBuilding_1 = require("../arguments/ArgumentBuilding");
const BuildDataValue_1 = __importDefault(require("../utils/BuildDataValue"));
function default_1(path, model, middleware, dataArguments) {
    return {
        path: `${path}/insert`,
        type: "Insert",
        execute: (args = {}) => __awaiter(this, void 0, void 0, function* () {
            return ExecuteMiddleware_1.default(middleware, args).then((result) => {
                if (result.error.length > 0) {
                    return result;
                }
                return ArgumentBuilding_1.argumentBuilding(args.data, dataArguments).then((dataResult) => {
                    if (dataResult.error.length === 0) {
                        return model.insert(BuildDataValue_1.default(dataResult)).then((data) => {
                            if (Array.isArray(data)) {
                                result.error.push(...data);
                            }
                            else {
                                result.data.push(model.toExport(data));
                            }
                            return result;
                        });
                    }
                    else {
                        return dataResult;
                    }
                });
            });
        })
    };
}
exports.default = default_1;
//# sourceMappingURL=InsertModel.js.map