"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ExecuteMiddleware_1 = __importDefault(require("../middleware/ExecuteMiddleware"));
const ArgumentBuilding_1 = require("../arguments/ArgumentBuilding");
const BuildFilter_1 = __importDefault(require("../utils/BuildFilter"));
const BuildFindOption_1 = __importDefault(require("../utils/BuildFindOption"));
function default_1(path, model, middleware, filterArguments) {
    return {
        path: `${path}`,
        type: "Read",
        execute: (args = {}) => __awaiter(this, void 0, void 0, function* () {
            return ExecuteMiddleware_1.default(middleware, args).then((result) => {
                if (result.error.length > 0) {
                    return result;
                }
                return ArgumentBuilding_1.argumentBuilding(args.filter, filterArguments).then((filterResult) => {
                    if (filterResult.error.length === 0) {
                        return model.find(BuildFilter_1.default(filterResult.arguments), BuildFindOption_1.default(args.option)).then((data) => {
                            for (const d of data) {
                                result.data.push(model.toExport(d));
                            }
                            return result;
                        });
                    }
                    else {
                        return {
                            error: filterResult.error
                        };
                    }
                });
            });
        })
    };
}
exports.default = default_1;
//# sourceMappingURL=ReadModel.js.map