"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function default_1(core, middleware, args, type) {
    let promise = new Promise((resolve) => {
        resolve({
            error: [],
            data: [],
        });
    });
    for (const ware of middleware) {
        promise = promise.then((result) => {
            if (result.error.length > 0) {
                return result;
            }
            return ware[type](core, args).then((errors) => {
                result.error.push(...errors);
                return result;
            });
        });
    }
    return promise;
}
exports.default = default_1;
//# sourceMappingURL=ExecuteMiddleware.js.map