import { Value } from "../../../model";
import { Core, Error } from "../../../core";
export declare type Result = {
    data?: {
        [key: string]: any;
    };
    error?: Error[];
};
export declare type MetaData = {
    [key: string]: any;
};
export declare type ApiRequestArgument = {
    meta: MetaData;
    data: Value;
};
export declare type ApiRequestFunction = (core: Core, args: ApiRequestArgument) => Promise<Result>;
export declare type ApiRequest = {
    path: string;
    execute: ApiRequestFunction;
};
