import { Model } from "../../../model";
export declare type Argument = {
    [key: string]: any;
};
export declare type ArgumentError = {
    type: "Argument";
    name: string;
    message?: string;
};
export declare namespace ArgumentOptions {
    type PrioritySorted = Options[];
    type Options = {
        [key: string]: DefaultOption & (NameOption | ReferenceOption);
    };
    type Filter = {
        [key: string]: NameOption | ReferenceOption;
    };
    type DefaultOption = {
        priority: number;
        hidden: boolean;
    };
    type NameOption = {
        name: string;
        require: boolean;
    };
    type ReferenceOption = {
        model: Model;
        select: string;
        require: boolean;
        filter: Filter;
    };
}
