"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exitsOptionalArguments = exports.ifId = exports.exitsRequireArguments = void 0;
const __1 = require("../../..");
function exitsRequireArguments(args, names) {
    const errors = [];
    for (const name of names) {
        if (!args[name]) {
            errors.push({
                type: __1.ErrorType.Request,
                message: `The arguments '${name}' is require.`,
            });
        }
    }
    return errors;
}
exports.exitsRequireArguments = exitsRequireArguments;
function ifId(error, args, name, array = false) {
    const names = Array.isArray(name) ? name : [name];
    for (const n of names) {
        const value = args[n];
        let valueList = [];
        if (array && Array.isArray(value)) {
            valueList = value;
        }
        else {
            valueList.push(value);
        }
        for (const v of valueList) {
            // Exist the argument
            if (v === null || v === undefined || typeof v !== "string" || !(v.length === 12 || v.length === 24)) {
                // Throw the type error
                error.push({
                    type: __1.ErrorType.Request,
                    message: `The argument '${n}' must be have the type string and the length of ${12} or ${24}.`
                });
            }
        }
    }
}
exports.ifId = ifId;
function exitsOptionalArguments(error, args, name, type, require = false, execute, bad) {
    const value = args[name];
    // Exist the argument
    if (value !== null && value !== undefined) {
        if (type === "id") {
            // Exist the argument
            if (typeof value !== "string" || !(value.length === 12 || value.length === 24)) {
                // Throw the type error
                error.push({
                    type: __1.ErrorType.Request,
                    message: `The argument '${name}' must be have the type string and the length of ${12} or ${24}.`
                });
            }
        }
        else if (typeof value === type) {
            if (execute) {
                execute(value);
            }
        }
        else {
            // Throw the type error
            error.push({
                type: __1.ErrorType.Request,
                message: `The argument '${name}' must be have the type '${type}'`
            });
        }
    }
    else if (bad) {
        bad(value);
    }
    else if (require) {
        // Throw the type error
        error.push({
            type: __1.ErrorType.Request,
            message: `The argument '${name}' must be have require '${type}'`
        });
    }
}
exports.exitsOptionalArguments = exitsOptionalArguments;
//# sourceMappingURL=ArgumentUtils.js.map