import { Core, DataValue, Middleware, MiddlewareError, ValidatorError } from "../..";
export declare type ApiRequestSettings = {
    middleware: Middleware[];
    path: string;
    execute?: ApiRequestExtendFunction;
    model?: string;
    read?: boolean;
    insert?: boolean;
    update?: boolean;
    delete?: boolean;
};
export declare type ApiRequestOption = {
    core: Core;
    paths?: ApiPathOption[];
};
export declare type ApiPathOption = {
    path: string;
    middleware?: Middleware;
    children?: ApiPathOption[];
    execute?: ApiRequestExtendFunction;
    model?: string;
    read?: boolean;
    insert?: boolean;
    update?: boolean;
    delete?: boolean;
};
export declare type ApiRequest = {
    path: string;
    type: "Read" | "Insert" | "Update" | "Delete" | "Execute";
    execute: ApiRequestFunction;
};
export declare type ApiRequestArgument = {
    [key: string]: any;
};
export declare type ApiRequestResult = ApiRequestError & {
    data?: DataValue[];
};
export declare type ApiRequestError = {
    middleware: MiddlewareError[];
    validation: ValidatorError[];
};
export declare type ApiRequestFunction = (args?: ApiRequestArgument) => Promise<ApiRequestResult>;
export declare type ApiRequestExtendFunction = (core: Core, args: ApiRequestArgument) => Promise<ApiRequestResult>;
