"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function default_1(middleware, args) {
    let promise = new Promise((resolve) => {
        resolve({
            middleware: [],
            validation: [],
            data: [],
        });
    });
    for (const ware of middleware) {
        promise = promise.then((result) => {
            if (result.middleware.length > 0) {
                return result;
            }
            return ware.call(args).then((errors) => {
                result.middleware.push(...errors);
                return result;
            });
        });
    }
    return promise;
}
exports.default = default_1;
//# sourceMappingURL=ExecuteMiddleware.js.map