/// <reference types="node" />
import { Endpoint } from "../Endpoint";
import { ApiRequest } from "../generator";
export declare class RestApi extends Endpoint {
    readonly DefaultPort = 4000;
    readonly options: RestApiOption;
    private readonly _app;
    private _server;
    constructor(options?: RestApiOption);
    create(): Promise<void>;
    start(): Promise<void>;
    stop(): Promise<void>;
    destroy(): Promise<void>;
    protected useRequest(request: ApiRequest): void;
}
export declare type RestApiOption = {
    https?: boolean;
    port?: number;
    key?: string | Buffer;
    cert?: string | Buffer;
};
