import { Endpoint } from "../Endpoint";
import { ApiRequest, ApiRequestArgument, Result } from "../generator";
import { Core } from "../../core";
export declare class TestEndpoint extends Endpoint {
    private _request;
    private _test;
    constructor();
    protected useRequest(request: ApiRequest): void;
    addTest(test: TestGroup | TestRequest): void;
    executeTests(): Promise<TestResult[]>;
    executeGroup(group: TestGroup, store?: ArgumentStore): Promise<TestResult[]>;
    executeRequest(request: TestRequest, store?: ArgumentStore): Promise<TestResult>;
}
export declare type ArgumentStore = {
    [key: string]: any;
};
export declare type TestResult = {
    path: string;
    error: boolean;
    errorObject?: any;
};
export declare type TestGroup = {
    name: string;
    before?: (core: Core, store: ArgumentStore) => Promise<void>;
    after?: (core: Core, store: ArgumentStore) => Promise<void>;
    tests?: (TestGroup | TestRequest)[];
};
export declare type TestRequest = {
    path: string;
    name?: string;
    arguments: (core: Core, store: ArgumentStore) => Promise<ApiRequestArgument>;
    result: (core: Core, store: ArgumentStore, result: Result) => Promise<boolean | string | object>;
};
