/// <reference types="node" />
import { Endpoint } from "../Endpoint";
import { WsClient } from "./WsClient";
import { ApiRequest, ApiRequestFunction } from "../generator";
export declare class WsServer extends Endpoint {
    readonly DefaultPort = 4001;
    readonly options: WsServerOption;
    readonly endpoints: {
        [path: string]: ApiRequestFunction;
    };
    private _server;
    private _websocketServer;
    private _clients;
    constructor(options?: WsServerOption);
    create(): Promise<void>;
    start(): Promise<void>;
    stop(): Promise<void>;
    destroy(): Promise<void>;
    removeClient(client: WsClient): void;
    protected useRequest(request: ApiRequest): void;
    private openConnection;
}
export declare type WsServerOption = {
    https?: boolean;
    port?: number;
    key?: string | Buffer;
    cert?: string | Buffer;
};
