"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WsServer = void 0;
const WebSocket = __importStar(require("ws"));
const Endpoint_1 = require("../Endpoint");
const http_1 = __importDefault(require("http"));
const https_1 = __importDefault(require("https"));
const WsClient_1 = require("./WsClient");
const core_1 = require("../../core");
class WsServer extends Endpoint_1.Endpoint {
    constructor(options = {}) {
        super();
        this.DefaultPort = 4001;
        this.endpoints = {};
        this._clients = [];
        this.options = options;
    }
    create() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.options.https) {
                this._server = https_1.default.createServer({
                    key: this.options.key,
                    cert: this.options.cert
                });
            }
            else {
                this._server = http_1.default.createServer();
            }
            this._websocketServer = new WebSocket.Server({
                server: this._server
            });
            this.openConnection();
        });
    }
    start() {
        return __awaiter(this, void 0, void 0, function* () {
            const port = this.options.port | this.DefaultPort;
            core_1.Logger.info(`Websocket: Start server on ${port}`);
            this._server.listen(port);
        });
    }
    stop() {
        return __awaiter(this, void 0, void 0, function* () {
            for (const client of this._clients) {
                client.close();
            }
            this._clients = [];
            if (this._server) {
                this._server.close();
            }
            if (this._websocketServer) {
                this._websocketServer.close();
            }
        });
    }
    destroy() {
        return __awaiter(this, void 0, void 0, function* () {
            this._server = null;
            this._websocketServer = null;
        });
    }
    removeClient(client) {
        this._clients.filter(obj => obj !== client);
    }
    useRequest(request) {
        core_1.Logger.info(`Websocket: Add request at '${request.path}'`);
        this.endpoints[request.path] = request.execute;
    }
    openConnection() {
        this._websocketServer.on("connection", (ws) => {
            this._clients.push(new WsClient_1.WsClient(this.core, this, ws));
        });
    }
}
exports.WsServer = WsServer;
//# sourceMappingURL=WsServer.js.map