export declare type ModelSchema = {
    [data: string]: SchemaType;
};
export declare type ExportSchema = {
    [data: string]: SchemaTypeExport;
};
export declare type SchemaType = (SchemaString | SchemaNumber | SchemaRefs | SchemaId | SchemaBoolean) & SchemaTypeOptions & SchemaTypeExport & Modification;
export declare type SchemaId = {
    readonly type: "Id";
};
export declare type SchemaString = {
    readonly type: "String";
    min?: number;
    max?: number;
    trim?: boolean;
    default?: string;
    validate?: (value: string) => boolean;
};
export declare type SchemaNumber = {
    readonly type: "Number";
    min?: number;
    max?: number;
    default?: number;
    validate?: (value: number) => boolean;
};
export declare type SchemaBoolean = {
    readonly type: "Boolean";
    default?: boolean;
};
export declare type SchemaRefs = {
    readonly type: "Refs";
    model: string;
    idName: string;
    dependent?: boolean;
};
export declare type SchemaTypeOptions = {
    require?: boolean;
    protection?: boolean;
};
export declare type SchemaTypeExport = {
    export?: boolean;
    exportName?: string;
};
export declare type Modification = {
    name?: string;
    get?: (data: number | string | boolean) => number | string | boolean;
    set?: (data: number | string | boolean) => number | string | boolean;
};
