export declare type Filter = {
    [name: string]: number | boolean | string | string[] | FilterNumberOption;
};
export declare type FilterNumberOption = {
    min?: number;
    max?: number;
};
export declare type DBFilter = {
    [name: string]: DBFilterId | DBFilterString | DBFilterNumber | DBFilterRefs | DBFilterBoolean;
};
export declare type DBFilterId = {
    type: "Id";
    value: string | string[];
};
export declare type DBFilterRefs = {
    type: "Refs";
    value: string;
};
export declare type DBFilterString = {
    type: "String";
    value: string;
};
export declare type DBFilterBoolean = {
    type: "Boolean";
    value: boolean;
};
export declare type DBFilterNumber = {
    type: "Number";
    value?: number;
    min?: number;
    max?: number;
};
