export declare type FindFilter = {
    [name: string]: number | boolean | string | string[] | FilterNumberOption;
};
export declare type FilterNumberOption = {
    min?: number;
    max?: number;
};
export declare type FilterOption = {
    limit?: number;
    offset?: number;
};
export declare namespace DB {
    type DBFilter = {
        [name: string]: DBFilterId | DBFilterString | DBFilterNumber | DBFilterRefs | DBFilterBoolean;
    };
    type DBFilterId = {
        type: "Id";
        value: string | string[];
    };
    type DBFilterRefs = {
        type: "Refs";
        value: string | string[];
    };
    type DBFilterString = {
        type: "String";
        value: string;
    };
    type DBFilterBoolean = {
        type: "Boolean";
        value: boolean;
    };
    type DBFilterNumber = {
        type: "Number";
        value?: number;
        min?: number;
        max?: number;
    };
}
