"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function default_1(model, filter) {
    const modelSchema = model.schema;
    const modificationFilter = {};
    for (let name in modelSchema) {
        const schema = modelSchema[name];
        const value = filter[name];
        if (!value) {
            continue;
        }
        if (schema.name) {
            name = schema.name;
        }
        switch (schema.type) {
            case "Id":
                if (typeof value === "string" || Array.isArray(value)) {
                    modificationFilter[name] = {
                        type: "Id",
                        value
                    };
                }
                break;
            case "Refs":
                if (typeof value === "string" || Array.isArray(value)) {
                    modificationFilter[name] = {
                        type: "Refs",
                        value
                    };
                }
                break;
            case "String":
                if (typeof value === "string") {
                    modificationFilter[name] = {
                        type: "String",
                        value
                    };
                }
                break;
            case "Boolean":
                if (typeof value === "boolean") {
                    modificationFilter[name] = {
                        type: "Boolean",
                        value
                    };
                }
                break;
            case "Number":
                if (typeof value === "object") {
                    modificationFilter[name] = Object.assign({ type: "Number" }, value);
                }
                else if (typeof value === "number") {
                    modificationFilter[name] = {
                        type: "Number",
                        value
                    };
                }
                break;
        }
    }
    return modificationFilter;
}
exports.default = default_1;
//# sourceMappingURL=DBFilter.js.map