"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function default_1(model, data) {
    const modelSchema = model.schema;
    const modificationData = {};
    for (let name in data) {
        let value = data[name];
        const type = typeof value;
        // If the type not a string, number or boolean than parse to a string
        if (!(type === "number" || type === "boolean" || type === "string")) {
            value = `${value}`;
        }
        // Parse the db name to the visible name
        for (const key in modelSchema) {
            const def = modelSchema[key];
            if (def && def.name && def.name === name) {
                name = key;
                break;
            }
        }
        // If exist a get modification function than execute this
        const schema = modelSchema[name];
        if (schema) {
            if (schema.get) {
                value = schema.get(value);
            }
            modificationData[name] = value;
        }
    }
    return modificationData;
}
exports.default = default_1;
//# sourceMappingURL=DBPastprocessing.js.map