"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function default_1(model, data, setDefaults = false) {
    const modelSchema = model.schema;
    const modificationData = {};
    if (setDefaults) {
        for (const key in modelSchema) {
            if (data[key] === undefined) {
                const schemaType = modelSchema[key];
                if (schemaType.type === "Boolean" || schemaType.type === "String" || schemaType.type === "Number") {
                    if (schemaType.default) {
                        if (typeof schemaType.default === "function") {
                            data[key] = schemaType.default();
                        }
                        else {
                            data[key] = schemaType.default;
                        }
                    }
                }
            }
        }
    }
    for (let name in data) {
        let value = data[name];
        const schema = modelSchema[name];
        if (schema) {
            if (schema.name) {
                name = schema.name;
            }
            if (schema.set) {
                value = schema.set(value);
            }
            modificationData[name] = value;
        }
    }
    return modificationData;
}
exports.default = default_1;
//# sourceMappingURL=DBPreprocessing.js.map