export declare type ModelSchema = {
    [data: string]: SchemaType;
};
export declare type SchemaType = (Types.String | Types.Number | Types.Reference | Types.Id | Types.Boolean) & Optional.Option & Optional.Export.Export & Optional.Modification;
export declare namespace Types {
    type Id = {
        readonly type: "Id";
    };
    type String = {
        readonly type: "String";
        min?: number;
        max?: number;
        trim?: boolean;
        default?: string | (() => string);
        validate?: (value: string) => boolean;
    };
    type Number = {
        readonly type: "Number";
        min?: number;
        max?: number;
        default?: number | (() => number);
        validate?: (value: number) => boolean;
    };
    type Boolean = {
        readonly type: "Boolean";
        default?: boolean;
    };
    type Reference = {
        readonly type: "Refs";
        model: string;
        idName: string;
        dependent?: boolean;
    };
}
export declare namespace Optional {
    type Option = {
        require?: boolean;
        protection?: boolean;
    };
    type Modification = {
        name?: string;
        get?: (data: number | string | boolean) => number | string | boolean;
        set?: (data: number | string | boolean) => number | string | boolean;
    };
    namespace Export {
        type Export = {
            export?: boolean;
            exportName?: string;
        };
        type ExportSchema = {
            [data: string]: Export;
        };
    }
}
