import { Model } from "../model";
import { Value } from "../model/Model";
export declare class Trigger {
    private _listener;
    addListener(listener: TriggerListener): void;
    triggerInsert(model: Model, insert: Value): Promise<void>;
    triggerUpdate(model: Model, data: Value, updates: Value): Promise<void>;
    triggerDelete(model: Model, data: Value): Promise<void>;
    clear(): void;
}
export declare type TriggerListener = {
    insert?: (model: Model, insert: Value) => Promise<void>;
    update?: (model: Model, data: Value, updates: Value) => Promise<void>;
    delete?: (model: Model, data: Value) => Promise<void>;
};
