"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("../core");
const listener = {
    insert(model, values) {
        return __awaiter(this, void 0, void 0, function* () {
            core_1.Logger.info(`Insert data into ${model.name}: ${JSON.stringify(values)}`);
        });
    },
    update(model, data, updates) {
        return __awaiter(this, void 0, void 0, function* () {
            core_1.Logger.info(`Update data from ${model.name}: ${JSON.stringify(data)} - ${JSON.stringify(updates)}`);
        });
    },
    delete(model, data) {
        return __awaiter(this, void 0, void 0, function* () {
            core_1.Logger.info(`Delete data out ${model.name}: ${JSON.stringify(data)}`);
        });
    }
};
exports.default = listener;
//# sourceMappingURL=TriggerLogger.js.map