import {Model} from "../../../src/model";
import {Core}  from "../../../src/core";

export default (core: Core): Model => {
    return new Model('User',
        {
            id: {
                type: 'Id',
                name: '_id'
            },
            firstName: {
                type: "String",
            },
            lastName: {
                type: "String",
            },
            company: {
                type: "Refs",
                model: "Company",
                idName: "id"
            }
        }, {
            helloWorld: async (hello: string): Promise<string> => {
                return hello;
            }
        }
    )
}
